﻿using System.Windows.Forms;
using System.Data;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace WindowsFormsApplication365
{
    public partial class Form1 : Form
    {

        public class ResetGrid
        {
            UltraGrid grid;
            public UltraGrid Grid
            {
                get { return grid; }
                //set { grid = value; }
            } 


            bool resetRequered = true;
            object ds = null;

            public ResetGrid(UltraGrid grid)
            {
                this.grid = grid;
                grid.BeforeColumnChooserDisplayed += new BeforeColumnChooserDisplayedEventHandler(grid_BeforeColumnChooserDisplayed);
                ResetGridDataSourse = new ResetGridData(reset);
            }

            public ResetGrid(UltraGrid grid, UltraGridColumnChooser chooser)
            {
                this.grid = grid;
                ResetGridDataSourse = new ResetGridData(reset);
                HandelColumnChooserGrid(chooser);
                grid.BeforeColumnChooserDisplayed += new BeforeColumnChooserDisplayedEventHandler(grid_BeforeColumnChooserDisplayed);
            }

            void HandelColumnChooserGrid(Control c)
            {
                if (c is ColumnChooserGrid)
                {
                    ((ColumnChooserGrid)c).MouseUp += new MouseEventHandler(ResetGrid_MouseUp);
                }
                if (c == null)
                    return;
                foreach (Control c1 in c.Controls)
                    HandelColumnChooserGrid(c1);
            }

            void ResetGrid_MouseUp(object sender, MouseEventArgs e)
            {
                if (resetRequered)
                {
                    ResetGridDataSourse.Invoke(grid, this.ds);
                }
            }


            void ResetGrid_ClickCell(object sender, ClickCellEventArgs e)
            {
               
                if (resetRequered)
                    ResetGridDataSourse.Invoke(sender, this.ds);
            }

            void grid_BeforeColumnChooserDisplayed(object sender, BeforeColumnChooserDisplayedEventArgs e)
            {
                HandelColumnChooserGrid(e.Dialog.ColumnChooserControl);
            
            }

            private delegate void ResetGridData(object sender, object dataSorce);
            private ResetGridData ResetGridDataSourse;

            public void RequestResetData(object dataSourse)
            {
                resetRequered = true;
                this.ds = dataSourse;
            }

            void reset(object sender, object dataSourse)
            {
                UltraGrid grid = sender as UltraGrid;
                if (grid != null)
                {
                    grid.DataSource = ds;
                    resetRequered = false;
                }
            }

        }

        ResetGrid gridManager;

        public Form1()
        {
            InitializeComponent();
            gridManager = new ResetGrid(ultraGrid1, ultraGridColumnChooser1);
            //use the following constructor if you will using default coulnchoouser
            //gridManager = new ResetGrid(ultraGrid1);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.ColumnChooserEnabled = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.RowSelectorHeaderStyle = Infragistics.Win.UltraWinGrid.RowSelectorHeaderStyle.ColumnChooserButton;
        }

        void ultraGrid1_AfterExitEditMode(object sender, System.EventArgs e)
        {

            // I've put this line here for ease. In my own code, I reconstruct the datasource after a change by the user.
            // this leads to the columns being recreated.
            gridManager.RequestResetData(null);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            ultraGridColumnChooser1.Dispose();
        }

       

        
    }
}
